'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.actionless = actionless;
exports.entitiesReducer = entitiesReducer;
exports.combineEntitiesReducers = combineEntitiesReducers;

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _mapValues = require('lodash/mapValues');

var _mapValues2 = _interopRequireDefault(_mapValues);

var _merge = require('lodash/merge');

var _merge2 = _interopRequireDefault(_merge);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function selectEntities(action, name) {
  var entities = (0, _get2.default)(action, 'payload.entities.' + name);
  if (entities) {
    return entities;
  }
}

function actionless() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  return state;
}

function entitiesReducer(reducer, entitiesName) {
  return function (state, action) {
    var newState = state;
    var entities = (0, _isFunction2.default)(entitiesName) ? entitiesName(action) : selectEntities(action, entitiesName);

    if (entities) {
      newState = (0, _merge2.default)({}, newState, entities);
    }

    return reducer(newState, action);
  };
}

function combineEntitiesReducers(reducers) {
  var entitiesReducers = (0, _mapValues2.default)(reducers, entitiesReducer);
  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var action = arguments[1];
    return (0, _mapValues2.default)(entitiesReducers, function (reducer, key) {
      return reducer(state[key], action);
    });
  };
}